Project Chrono: chrono::ChLinkRevoluteSpherical Class Reference

Public Member Functions | List of all members
chrono::ChLinkRevoluteSpherical Class Reference

## Description

Composite revolute-spherical joint between two two bodies.

This joint is defined through a point and direction on the first body (the revolute side), a point on the second body (the spherical side), and a distance. Kinematically, the two points are maintained at the prescribed distance while the vector between the two points is always perpendicular to the provided direction of the revolute joint.

`#include <ChLinkRevoluteSpherical.h>`

Inheritance diagram for chrono::ChLinkRevoluteSpherical:
[legend]
Collaboration diagram for chrono::ChLinkRevoluteSpherical:
[legend]

## Public Member Functions
| ChLinkRevoluteSpherical (const ChLinkRevoluteSpherical &other)
virtual ChLinkRevoluteSpherical * | Clone () const override
| "Virtual" copy constructor (covariant return type).
virtual unsigned int | GetNumConstraintsBilateral () override
| Get the number of (bilateral) constraints introduced by this joint.
const ChVector3d & | GetPoint1Rel () const
| Get the point on m_body1 (revolute side), expressed in body 1 coordinate system.
const ChVector3d & | GetDir1Rel () const
| Get the direction of the revolute joint, expressed in body 1 coordinate system.
const ChVector3d & | GetPoint2Rel () const
| Get the point on m_body2 (spherical side), expressed in body 2 coordinate system.
double | GetImposedDistance () const
| Get the imposed distance (length of massless connector).
double | GetCurrentDistance () const
| Get the current distance between the two points.
ChVector3d | GetPoint1Abs () const
| Get the point on m_body1 (revolute side), expressed in absolute coordinate system.
ChVector3d | GetDir1Abs () const
| Get the direction of the revolute joint, expressed in absolute coordinate system.
ChVector3d | GetPoint2Abs () const
| Get the point on m_body2 (spherical side), expressed in absolute coordinate system.
virtual ChFrame | GetFrame1Rel () const override
| Get the link frame 1, relative to body 1.
virtual ChFrame | GetFrame2Rel () const override
| Get the link frame 2, relative to body 2.
virtual ChWrenchd | GetReaction1 () const override
| Get the reaction force and torque on the 1st body, expressed in the link frame 1.
virtual ChWrenchd | GetReaction2 () const override
| Get the reaction force and torque on the 2nd body, expressed in the link frame 2.
virtual ChVectorDynamic | GetConstraintViolation () const override
| Get the joint violation (residuals of the constraint equations).
void | Initialize (std::shared_ptr< ChBody > body1, std::shared_ptr< ChBody > body2, const ChCoordsys<> &csys, double distance)
| Initialize this joint by specifying the two bodies to be connected, a coordinate system specified in the absolute frame, and the distance of the massless connector.
void | Initialize (std::shared_ptr< ChBody > body1, std::shared_ptr< ChBody > body2, bool local, const ChVector3d &pos1, const ChVector3d &dir1, const ChVector3d &pos2, bool auto_distance=true, double distance=0)
| Initialize this joint by specifying the two bodies to be connected, a point and a direction on body1 defining the revolute joint, and a point on the second body defining the spherical joint.
virtual void | Update (double time, bool update_assets=true) override
| Perform the update of this joint at the specified time: compute jacobians, constraint violations, etc.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChLink
| ChLink (const ChLink &other)
virtual unsigned int | GetNumAffectedCoords () override
| Get the number of scalar variables affected by constraints in this link.
ChBodyFrame * | GetBody1 () const
| Get the constrained body 1.
ChBodyFrame * | GetBody2 () const
| Get the constrained body 2.
virtual ChFramed | GetFrame1Abs () const override
| Get the link frame 1, on body 1, expressed in the absolute frame.
virtual ChFramed | GetFrame2Abs () const override
| Get the link frame 2, on body 2, expressed in the absolute frame.
virtual void | UpdateTime (double mytime)
| Given new time, current body state, update time-dependent quantities in link state, for example motion laws, moving markers, etc.
virtual void | Update (bool update_assets=true) override
| As above, but with current time.
virtual void | UpdatedExternalTime (double prevtime, double time)
| Called from a external package (i.e. a plugin, a CAD app.) to report that time has changed.
Public Member Functions inherited from chrono::ChLinkBase
| ChLinkBase (const ChLinkBase &other)
bool | IsValid ()
| Tells if the link data is currently valid.
void | SetValid (bool mon)
| Set the status of link validity.
bool | IsDisabled ()
| Tells if all constraints of this link are currently turned on or off by the user.
virtual void | SetDisabled (bool mdis)
| User can use this to enable/disable all the constraint of the link as desired.
bool | IsBroken ()
| Tells if the link is broken, for excess of pulling/pushing.
virtual void | SetBroken (bool mon)
| Set the 'broken' status vof this link.
virtual bool | IsActive () const override
| Return true if the link is currently active and thereofre included into the system solver.
virtual bool | IsRequiringWaking ()
| Tells if this link requires that the connected ChBody objects must be waken if they are sleeping.
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const override
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumCoordsPosLevel ()
| Get the number of coordinates at the position level.
virtual unsigned int | GetNumCoordsVelLevel ()
| Get the number of coordinates at the velocity level.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T)
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update)
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a)
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a)
| From global acceleration vector to item's state acceleration.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c)
| Takes the F force term, scale and adds to R at given offset: R += c*F.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c)
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c)
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c)
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | InjectVariables (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset ()
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1)
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed ()
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq ()
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0)
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step)
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiLoad_Ct (double factor=1)
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFbLoadForces (double factor=1)
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()
Protected Attributes inherited from chrono::ChLink
ChBodyFrame * | m_body1
| first connected body
ChBodyFrame * | m_body2
| second connected body
ChVector3d | react_force
| xyz reactions, expressed in local coordinate system of link;
ChVector3d | react_torque
| torque reactions, expressed in local coordinate system of link;
Protected Attributes inherited from chrono::ChLinkBase
bool | disabled
| all constraints of link disabled because of user needs
bool | valid
| link data is valid
bool | broken
| link is broken because of excessive pulling/pushing.
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::ChLinkRevoluteSpherical::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Method to allow de serialization of transient data from archives.

Reimplemented from chrono::ChLink.

## ◆ ArchiveOut()

void chrono::ChLinkRevoluteSpherical::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChLink.

## ◆ Clone()

virtual ChLinkRevoluteSpherical * chrono::ChLinkRevoluteSpherical::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetConstraintViolation()

virtual ChVectorDynamic chrono::ChLinkRevoluteSpherical::GetConstraintViolation | ( |  | ) | const
| inlineoverridevirtual

Get the joint violation (residuals of the constraint equations).

Reimplemented from chrono::ChLinkBase.

## ◆ GetFrame1Rel()

ChFrame chrono::ChLinkRevoluteSpherical::GetFrame1Rel | ( |  | ) | const
| overridevirtual

Get the link frame 1, relative to body 1.

This frame, defined on body 1 (the revolute side), is centered at the revolute joint location, has its X axis along the joint connector, and its Z axis aligned with the revolute axis.

Implements chrono::ChLink.

## ◆ GetFrame2Rel()

ChFrame chrono::ChLinkRevoluteSpherical::GetFrame2Rel | ( |  | ) | const
| overridevirtual

Get the link frame 2, relative to body 2.

This frame, defined on body 2 (the spherical side), is centered at the spherical joint location, has its X axis along the joint connector, and its Z axis aligned with the revolute axis.

Implements chrono::ChLink.

## ◆ GetNumConstraintsBilateral()

virtual unsigned int chrono::ChLinkRevoluteSpherical::GetNumConstraintsBilateral | ( |  | ) |
| inlineoverridevirtual

Get the number of (bilateral) constraints introduced by this joint.

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetReaction1()

ChWrenchd chrono::ChLinkRevoluteSpherical::GetReaction1 | ( |  | ) | const
| overridevirtual

Get the reaction force and torque on the 1st body, expressed in the link frame 1.

Reimplemented from chrono::ChLink.

## ◆ GetReaction2()

ChWrenchd chrono::ChLinkRevoluteSpherical::GetReaction2 | ( |  | ) | const
| overridevirtual

Get the reaction force and torque on the 2nd body, expressed in the link frame 2.

Reimplemented from chrono::ChLink.

## ◆ Initialize() [1/2]

void chrono::ChLinkRevoluteSpherical::Initialize | ( | std::shared_ptr< ChBody > | body1,
|  | std::shared_ptr< ChBody > | body2,
|  | bool | local,
|  | const ChVector3d & | pos1,
|  | const ChVector3d & | dir1,
|  | const ChVector3d & | pos2,
|  | bool | auto_distance = true,
|  | double | distance = 0 )

Initialize this joint by specifying the two bodies to be connected, a point and a direction on body1 defining the revolute joint, and a point on the second body defining the spherical joint.

If local = true, it is assumed that these quantities are specified in the local body frames. Otherwise, it is assumed that they are specified in the absolute frame. The imposed distance between the two points can be either inferred from the provided configuration (auto_distance = true) or specified explicitly.

Parameters

  body1 | first frame (revolute side)
  body2 | second frame (spherical side)
  local | true if data given in body local frames
  pos1 | point on first frame (center of revolute)
  dir1 | direction of revolute on first frame
  pos2 | point on second frame (center of spherical)
  auto_distance | true if imposed distance equal to |pos1 - po2|
  distance | imposed distance (used only if auto_distance = false)

## ◆ Initialize() [2/2]

void chrono::ChLinkRevoluteSpherical::Initialize | ( | std::shared_ptr< ChBody > | body1,
|  | std::shared_ptr< ChBody > | body2,
|  | const ChCoordsys<> & | csys,
|  | double | distance )

Initialize this joint by specifying the two bodies to be connected, a coordinate system specified in the absolute frame, and the distance of the massless connector.

The composite joint is constructed such that the direction of the revolute joint is aligned with the Z axis of the specified coordinate system and the spherical joint is at the specified distance along the X axis.

Parameters

  body1 | first frame (revolute side)
  body2 | second frame (spherical side)
  csys | joint coordinate system (in absolute frame)
  distance | imposed distance

## ◆ Update()

void chrono::ChLinkRevoluteSpherical::Update | ( | double | time,
|  | bool | update_assets = true )
| overridevirtual

Perform the update of this joint at the specified time: compute jacobians, constraint violations, etc.

and cache in internal structures

Reimplemented from chrono::ChLink.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLinkRevoluteSpherical.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLinkRevoluteSpherical.cpp